;         /\  _  \                                    
;         \ \ \L\ \    ___      __   _ __   __  __    
;          \ \  __ \ /' _ `\  /'_ `\/\`'__\/\ \/\ \   
;           \ \ \/\ \/\ \/\ \/\ \L\ \ \ \/ \ \ \_\ \  
;            \ \_\ \_\ \_\ \_\ \____ \ \_\  \/`____ \ 
;             \/_/\/_/\/_/\/_/\/___L\ \/_/   `/___/> \
;                                 /\____/       /\___/
;                                \_/__/         \/__/ 
;          ____                    __                          
;         /\  _`\                 /\ \                         
;         \ \ \/\ \    ___     ___\ \ \/'\      __   __  __    
;          \ \ \ \ \  / __`\ /' _ `\ \ , <    /'__`\/\ \/\ \   
;           \ \ \_\ \/\ \L\ \/\ \/\ \ \ \\`\ /\  __/\ \ \_\ \  
;            \ \____/\ \____/\ \_\ \_\ \_\ \_\ \____\\/`____ \ 
;             \/___/  \/___/  \/_/\/_/\/_/\/_/\/____/ `/___/> \
;                                                        /\___/
;                                                        \/__/ 
;==============================================================================
; License
;==============================================================================
#CS
    Angry Donkey - A simple console tool for misc computer automation tasks
    Copyright (C) 2005 Eric Carmichael

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Insolence_9@yahoo.com
	3305 Lodgepole RD
	Coeur D Alene, ID 83815
#CE

;==============================================================================
; Splash image
;==============================================================================
;SplashImageOn( "The Angry Donkey", "angry donkey.jpg", 184, 204 )
;Sleep(3000)
;SplashOff ( )

;==============================================================================
; Settings
;==============================================================================
;#NoTrayIcon

;==============================================================================
; Variables
;==============================================================================
Global  $strInput, $editOutput, $inputInput, $arFunction[1], $intFunctions = 0,_
		$arFunctionAttribute[1][4], $boolConsoleInUse = 0, $funcConsoleHandler,_ 
		$OldChatLine = "", $OldUserLine = "", $UserRights

;==============================================================================
; Includes
;==============================================================================
#include <GuiConstants.au3>
#include <Functions.au3>
#include <Array.au3>
#include <File.au3>

;==============================================================================
; GUI
;==============================================================================
; Script generated by AutoBuilder 0.5 Prototype

GuiCreate("Console - The Angry Donkey by Eric Carmichael", 515, 414, -1, -1, $WS_BORDER )
GUISetFont ( 9, -1, -1, "Courier New")

$editOutput = GuiCtrlCreateEdit		("", 0, 0, 512, 364, $ES_AUTOVSCROLL + $ES_READONLY + $ES_MULTILINE + $WS_VSCROLL)
	GuiCtrlSetData ( $editOutput,  _
				"Angry Donkey version 0.0.2.5, Copyright (C) 2005 Eric Carmichael" & _ 
		@CRLF & "	Angry Donkey comes with ABSOLUTELY NO WARRANTY; for details" & _ 
		@CRLF & "	type license'.  This is free software, and you are welcome" & _ 
		@CRLF & "	to redistribute it under certain conditions; type license'" & _ 
		@CRLF & "	for details." & _ 
		@CRLF & @CRLF & "Welcome to Angry Donkey, type help for a list of functions." & _ 
		@CRLF & @CRLF)
	GUICtrlSetBkColor(-1,0x000000)
	GUICtrlSetColor(-1,0xC0C0C0)
	
$inputInput = GuiCtrlCreateInput	("", 0, 364, 512, 20)
	GUICtrlSetBkColor(-1,0x000000)
	GUICtrlSetColor(-1,0xC0C0C0)
	
GuiSetState()
GUICtrlSetState ( $inputInput, $GUI_FOCUS )

;==============================================================================
; GUI Loop
;==============================================================================
While 1
	Local $Update = 0
	;$msg = GuiGetMsg()
	;If $msg = $GUI_EVENT_CLOSE Then Exit
		
		; SOON TO BE ADDED
		; Checking whether another function is using the console explicitly
		;If $boolConsoleInUse = 1 Then
		;	; If so register the new function
		;	ConsoleHandler ( $funcConsoleHandler )
		;EndIf
		
	; Regular command parser	
    While WinActive("Console - The Angry Donkey by Eric Carmichael") = 1
		$msg = GuiGetMsg()
		If $msg = $GUI_EVENT_CLOSE Then Exit
			
		If _IsPressed('0d') = 1 Then ConsoleEnter()
			
		Sleep(1)	
    WEnd
	
    While WinExists("Chat - The Angry Donkey by Eric Carmichael") = 1
		$msg = GuiGetMsg()
		If $msg = $GUI_EVENT_CLOSE Then Exit
			
		If _IsPressed('0d') = 1 AND WinActive("Chat - The Angry Donkey by Eric Carmichael") = 1 Then ChatEnter()
			
		UpdateChat()
		If $Update = 20 Then
			UpdateUsers()
			$Update = 0
		Else
			$Update = $Update + 1
		EndIf
		
		Sleep(10)
	WEnd
WEnd

;==============================================================================
; GUI Handlers
;==============================================================================
Func ConsoleEnter()
	; Parameters are global so the function knows what to do
	Global $arParameter[255]
	Local $strInput
	
	;Handling input
	$strInput = GUICtrlRead ( $inputInput )
	GuiCtrlSetData ( $inputInput, "" )
	
	;Determining whether input is valid
	If $strInput <> "" Then 
		Output($strInput)
		GUICtrlSetState ( $inputInput, $GUI_FOCUS )
		
		DoAction($strInput)
	EndIf
EndFunc

Func ChatEnter()
	Local $strInput, $strTemp
	
	;Handling input
	$strInput = GUICtrlRead ( $inputChatInput )
	GuiCtrlSetData ( $inputChatInput, "" )
	
	;Determining whether input is valid
	If $strInput <> "" Then		
		; Checking whether a command trigger hit
		If StringMid($strInput, 1, 1) = "/" Then 
			$strTemp = Parse($strInput)
			; Checking whether or not user trying to use the connect function, while connected
			If $strTemp[0] <> "Connect" Then
				DoAction($strInput)
			Else
				Output( "ERROR: You cannot use that function here" )
			EndIf
		Else
			; Checking for gloabl user command
			If StringMid($strInput, 1, 1) = "`" Then 
				If $UserRights = "F" OR $UserRights = "O" OR $UserRights = "H" Then 
					SendMessage( "/" & StringTrimLeft($strInput,1),0)
				Else
					Output( "ERROR: You cannot send global commands, newb." )
				EndIf
			Else
				SendMessage($strInput)
			EndIf	
		EndIf
	EndIf
EndFunc

;==============================================================================
; Clean up
;==============================================================================
Func OnAutoItExit()
	INetGet ( "http://www.insolence9.com/chat/testing2.php?action=logout", @TempDir & "/logout.txt", 1 )
EndFunc

;==============================================================================
; Functions
;==============================================================================
Func Output($text, $flag = 0)
    If WinActive("Console - The Angry Donkey by Eric Carmichael") Then 
		Local $DoGreaterThan = "> "
		If $Flag > 0 Then $DoGreaterThan = ""
		GuiCtrlSetData ( $editOutput, $DoGreaterThan & $text & @CRLF, "Append" )	
	Else
		GuiCtrlSetData ( $editChatOutput, $text & @CRLF, "Append" )	
	EndIf
EndFunc

Func UserListOutput($text)
	GuiCtrlSetData ( $editChatUserList, $text & @CRLF, "Append" )
EndFunc

; Thanks to Saunders for this one :)
Func Parse($s_Input)
	Local $a_Params, $i
	
    $s_Input = StringReplace($s_Input, '\"', Chr(1))

    $a_Params = StringRegExp($s_Input, '([0-9]+)|"(.*?)"|(\w+)', 3)

    For $i = 0 to UBound($a_Params) - 1
        $s_Param = $a_Params[$i]
        $s_Param = StringReplace($s_Param, Chr(1), '"')
        $a_Params[$i] = $s_Param
    Next
    
    Return $a_Params
EndFunc

Func _IsPressed($hexKey)
	Local $aR, $bO
	
	$hexKey = '0x' & $hexKey
	$aR = DllCall("user32", "int", "GetAsyncKeyState", "int", $hexKey)
	If Not @error And BitAND($aR[0], 0x8000) = 0x8000 Then
		$bO = 1
	Else
		$bO = 0
	EndIf
	
	Return $bO
EndFunc  

Func DoAction($Text)	
	Local $strTemp, $strFunction, $i, $Return, $intFunctionID
	; $strTemp[0] = Function name
	; $strTemp[n] = Parameter
	$strTemp = Parse($Text)	
	
	; Finding function
	For $i = 0 to UBound($arFunction) - 1
		If $arFunction[$i] = $strTemp[0] Then $intFunctionID = $i + 1
	Next
	
	; Testing function validity
	If $intFunctionID <> "" Then 		
		
		; Pushing parameters to global array, skipping first element because it's the function name
		For $i = 1 to UBound($strTemp) - 1
			; 1 offset for UBound...
			$arParameter[$i - 1] = $strTemp[$i]
		Next
		
		; Reset the array to given number of parameters
		ReDim $arParameter[$i]
		
		; If the minimum number of parameters is met, and the maximum is not exceeded
		If 	UBound($strTemp) - 1 >= $arFunctionAttribute[$intFunctionID - 1][0] AND _
			UBound($strTemp) - 1 <= $arFunctionAttribute[$intFunctionID - 1][1] Then
			
			$Return = Call( $strTemp[0] )
			If @error = 1 Then 
				Output("INTERNAL ERROR: " & $strTemp[0] & " not found.", 1)
			Else
				If $Return <> "" Then Output($Return, 1)
			EndIf
		Else
			Output("ERROR: Invalid parameters for " & $strTemp[0] & ".", 1)
		EndIf
	Else
		Output("ERROR: " & $strTemp[0] & " not defined.", 1)
	EndIf
EndFunc