;==============================================================================
; License
;==============================================================================
#CS
    Angry Donkey - A simple console tool for misc computer automation tasks
    Copyright (C) 2005 Eric Carmichael

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Insolence_9@yahoo.com
	3305 Lodgepole RD
	Coeur D Alene, ID 83815
#CE

Func Help()
	Local $intFunctionID = -1, $arTempFunctions
	
	; If no parameter given, list all functions
	If $arParameter[0] = "" Then
		$arTempFunctions = $arFunction
		_ArraySort( $arTempFunctions )
		
		Output( "Usable functions:", 1 )
		
		; Spit back functions
		For $i = 0 to UBound($arTempFunctions) - 1
			Output( "    " & $arTempFunctions[$i], 1)
		Next
	Else
		; Finding function ID
		For $i = 0 to UBound($arFunction) - 1
			If $arFunction[$i] = $arParameter[0] Then $intFunctionID = $i
		Next
			
		If $intFunctionID = -1 Then Return "ERROR: " & $arParameter[0] & " not defined."	

		; Spit back the function name followed by its description	
		Output( $arFunction[$intFunctionID], 1 										)
		Output( '    Usage     ' & $arFunctionAttribute[$intFunctionID][2], 1 		)
		Output( "    Function  " & $arFunctionAttribute[$intFunctionID][3], 1 		)	
	EndIf
EndFunc

Func Quit()
	Exit
EndFunc

Func License()
	Output( "More information avaliable at: www.gnu.org", 1 )
EndFunc